<?php
/*****************************************************************************
 * ID   : $Id: SiteObject.php,v 1.2 2007/04/11 12:58:47 secondarykey Exp $
 * Name : 
 * Specifications :
 ****************************************************************************/
$gSiteObject = null;
$gSiteReloadFlag = true;
class SiteObject
{
	var $config_tb;
	var $logArray = null;
	
	// コンストラクタ
	function SiteObject() {
	}

	//インスタンスを取得	
	function getInstance() {
		
		global $gSiteObject,$gSiteReloadFlag;
		if ( $gSiteObject == null ) {
			$gSiteObject = new SiteObject();
		}
		//読み込み指定がある場合	
		if ( $gSiteReloadFlag == true ) {
			$gSiteObject->reload();
		}
		return $gSiteObject;
	}

	/**
	 * リロード設定に変更する
	 */	
	function setReload() {
		global $gSiteReloadFlag;
		$gSiteReloadFlag = true;
	}
	
	/**
	 * データ作成
	 */
	function reload() {
		global $gSiteReloadFlag;
		//全件検索
		$tb = new config_tb;
		$configArray = $tb->select();
		$this->config_tb = $configArray[0];
		$gSiteReloadFlag = false;
		return;
	}

	/**
	 * サイトの名称を取得
	 */
	function name() {
		return $this->config_tb->SITE_TITLE();
	}

	/**
	 * サイトの説明を取得
	 */
	function detail() {
		return $this->config_tb->SITE_DESCRIPTION();
	}

	/**
	 * ページリストを追加
	 */	
	function pageList($aID,$aLimit=0) {
		//指定IDを親に持つページを検索
		$pageTb = new page_tb;
		$pageArray = $pageTb->selectParentID($aID,$aNum);
		if ($pageArray == null) {
			return null;
		}

		$pageList = array();
		//検索した数回繰り返す
		foreach ( $pageArray as $page ) {
			$pageList[] = PageObject::createPageObject($page);	
		}
		return $pageList;
	}

	/**
	 * ページオブジェクト取得
	 */	
	function page($aID) {
		$pageTb = new page_tb;
		$pageArray = $pageTb->selectByID($aID);
		if ( $pageArray == null ) {
			return null;
		}
		$page = $pageArray[0];
		return PageObject::createPageObject($page);	
	}

	/**
	 * RSSタグを作成
	 */
	function RSSTag() {
		$rtn = '<link rel="alternate" ' .
			   'type="application/rss+xml" ' .
			   'title="RSS 2.0" ' .
			   'href="./rss.php">';
		return $rtn;
	}

	/**
	 * 更新リストの生成
	 */	
	function updateList() {
		return $this->getLogArray();
	}

	/**
	 * 更新リスト(ページ指定)の生成
	 */	
	function updatePageList($aID) {
		$logs = array();
		$logtb = new log_tb;
		$logTables = $logtb->selectByRSS($aID);
		foreach ( $logTables as $log )	{
			$logs[] = new LogObject($log);
		}
		return $logs;
	}

	/**
	 * サイト変数を取得
	 */
	function get($aArg) {

		$obj = SiteObject::getInstance();
		$config = $obj->getObject();
		$rtn = "";
		
		switch ( $aArg ) {
    		//サイトの設定
    		case "ID":
    			$rtn = $config->ID();
    			break;
    		//サイトの設定
    		case "SITE_TITLE":
    			$rtn = $config->SITE_TITLE();
    			break;
    		//サイトの説明
    		case "SITE_DESCRIPTION":
    			$rtn = $config->SITE_DESCRIPTION();
    			break;
    		//サイトのRSS件数
    		case "SITE_RSS":
    			$rtn = $config->SITE_RSS();
    			break;
			//データベースサーバ
    		case "DATABASE_SERVER":
    			$rtn = DATABASE_SERVER;
    			break;
    		//データベースのユーザ
    		case "DATABASE_USER":
    			$rtn = DATABASE_USER;
    			break;
    		//データベースのパスワード
    		case "DATABASE_PASSWORD":
    			$rtn = DATABASE_PASSWORD;
    			break;
    		//データベース名称
    		case "DATABASE_NAME":
    			$rtn = DATABASE_NAME;
    			break;
    		//アプリケーション設定
    		case "APPLICATION_PATH":
    			$rtn = $config->APPLICATION_PATH();
    			break;
    		//アプリケーションURL
    		case "APPLICATION_URL":
    			$rtn = $config->APPLICATION_URL();
    			break;
    		//管理アプリケーションパス
    		case "APPLICATION_MANAGE_PATH":
    			$rtn = $config->APPLICATION_MANAGE_PATH();
    			break;
    		//管理アプリケーションURL
    		case "APPLICATION_MANAGE_URL":
    			$rtn = $config->APPLICATION_MANAGE_URL();
    			break;
    		//メールサーバ
    		case "POP3_SERVER":
    			$rtn = $config->POP3_SERVER();
    			break;
    		//メールサーバポート
    		case "POP3_PORT":
    			$rtn = $config->POP3_PORT();
    			break;
    		//メールサーバ アカウント
    		case "POP3_ACCOUNT":
    			$rtn = $config->POP3_ACCOUNT();
    			break;
    		//メールサーバ パスワード
    		case "POP3_PASSWORD":
    			$rtn = $config->POP3_PASSWORD();
    			break;
    		//メール受信アドレス
    		case "POP3_REVADDRESS":
    			$rtn = $config->POP3_REVADDRESS();
    			break;
    		//メール送信アドレス
    		case "POP3_SENDADDRESS":
    			$rtn = $config->POP3_SENDADDRESS();
    			break;
			case "SMARTY_TEMPLATE_PATH":
			case "TEMPLATE_PATH":
			case "TEMPLATE_SITE_PATH":
			case "TEMPLATE_PAGE_PATH":
			case "TEMPLATE_STATIC_PATH":
			
				$smartyTemplate = $config->APPLICATION_MANAGE_PATH() . 'templates/';
				if ( $aArg == "SMARTY_TEMPLATE_PATH" ) {
					$rtn = $smartyTemplate;
				} else {
					$template =	$smartyTemplate . 'template/';
					if ( $aArg == "TEMPLATE_PATH" ) {
						$rtn = $template;
					} else {
						if ( $aArg == "TEMPLATE_SITE_PATH" ) {
							$rtn = $template . 'site/';
						} else if ( $aArg == "TEMPLATE_PAGE_PATH" ) {
							$rtn = $template . 'page/';
						} else if ( $aArg == "TEMPLATE_STATIC_PATH" ) {
							$rtn = $template . 'static/';
						}
					}
				}
    			break;
			case "SMARTY_COMPILE_PATH":
				$rtn = $config->APPLICATION_MANAGE_PATH() . 'templates_c/';
    			break;
			case "SMARTY_CONFIG_PATH":
				$rtn = $config->APPLICATION_MANAGE_PATH() . 'configs/';
    			break;
			case "SMARTY_CACHE_PATH":
				$rtn = $config->APPLICATION_MANAGE_PATH() . 'cache/';
    			break;

			case "IMAGE_PATH":
				$rtn = $config->APPLICATION_PATH() . 'images/';
    			break;
			case "FILE_PATH":
				$rtn = $config->APPLICATION_PATH() . 'res/';
    			break;
			case "STATIC_PAGE_PATH":
				$rtn = $config->APPLICATION_PATH() . 'static/';
    			break;
		}

		return $rtn;
	}
	
	//マスタデータの検索用のメソッド
	function masterOption($aID,$aName="masterData",$aEmpty="",$aDefault="") {
		$masterData = new masterdata_tb;
		//マスタの一覧を作成
		$rtn = $masterData->getSelection($aDefault,$aID,$aName,$aEmpty);
		return $rtn;
	}
	
	/****************************************
	 * 以上は公開しているAPI これ以下は便利関数
	 ****************************************/
	function getObject() {
		return $this->config_tb;
	}
	
	/**
	 * ログオブジェクト取得
	 */
	function getLogArray() {
		if ( $this->myLogArray == null ) {
			
			$logs = array();
			$logtb = new log_tb;
			$logTables = $logtb->selectByRSS();
			foreach ( $logTables as $log )	{
				$logs[] = new LogObject($log);
			}
			$this->myLogArray = $logs;
		}
		return $this->myLogArray;
	}
	
}
?>
