<?php
/*****************************************************************************
 * ID   : $Id: page_editing_exec.php,v 1.2 2007/08/18 08:10:15 secondarykey Exp $
 * Name : ページ追加、更新時処理
 * Specifications :ページを追加、更新を行う場合のページ
 ****************************************************************************/
//全クラスの読み込み
require_once('application.php');

$smarty = new SmtTemplate;
//リンク相対パス
$smarty->assign('relative','../');

$exec = "";
//IDの設定がある場合
if ( isset($_POST['exec']) ) {
	//IDを設定
	$exec = $_POST['exec'];
}

//********************************************************

//ページ表示用のデータ
$id             = "";
$name           = "";
$detail         = "";
$alias          = "";
$selection_site = "";
$selection_page = "";
$parent_id      = "";
$createdate     = "";
$editdate       = "";

//挿入か更新の場合
if ( $exec == "insert" || $exec == "update" ) {

	//ページデータを取得
	$name      = $_POST['name'];
	$detail    = $_POST['detail'];
	$alias     = $_POST['alias'];
	$temp_site = $_POST['template_site_id'];
	$temp_page = $_POST['template_page_id'];
	$parent_id = $_POST['parent_id'];
	$priority  = $_POST['priority'];
	
	//データベースオブジェクトに設定
	$page_tb = new page_tb;
	$page_tb->setName($name);
	$page_tb->setDetail($detail);
	$page_tb->setParent_ID($parent_id);
	$page_tb->setAlias($alias);
	$page_tb->setTemplate_Site_ID($temp_site);
	$page_tb->setTemplate_Page_ID($temp_page);
	
	//現在の時刻の文字列を作成
	$stamp = time();
	$nowDate = date('Y-m-d H:i:s', $stamp);

	$createdate     = $nowDate;
	$editdate       = $nowDate;

	if ( $exec == "insert" ) {
		//作成、編集日付を設定
		$page_tb->setCreateDate($nowDate);
		$page_tb->setEditDate($nowDate);

		//親が持っているデータ数を取得	
		$ppageArray = page_tb::selectParentID($parent_id);
		$pcnt = count($ppageArray);
		$priority  = $pcnt + 1;
		//優先順位を設定
		$page_tb->setPriority($priority);

		//データを挿入する	
		$page_tb->insert();
		
		//挿入したIDを取得	
		$id = $page_tb->getID();

	} else if ( $exec == "update" ) {
		
		//現在のテンプレートと新しいテンプレートが違う場合
		//テンプレート用の行を削除
		//IDのデータを取得
		$id = $_POST['id'];
		//編集日付を設定
		$page_tb->setEditDate($nowDate);
		//優先順位もそのまま設定
		$page_tb->setPriority($priority);
		
		//IDのデータをアップデート
		$page_tb->update($id);
	}	
	
	header("Location: page_editing.php?id=".$id);
	
} else if ( $exec == "delete" ) {

	//IDの取得
	$id = $_POST['id'];

	//ルートIDの場合、削除を行わない
	if ( $id != PAGE_ROOTID ) {
	
		//下のページがないか確認
		$pageArray = page_tb::selectParentID($id,20);
		if ( $pageArray != null ) {
			$msg = "子ページが存在するため、削除できません。";
		} else {
		
			$pageTb = new page_tb();
			//ページをＩＤで検索
			$pageArray = $pageTb->selectByID($id);
			//ページデータを取得
			$pageData = $pageArray[0];
			//親ＩＤを取得	
			$parentID = $pageData->getParent_ID();
			$priority = $pageData->getPriority();
			$tmpID    = $pageData->getTemplate_Page_ID();
			//同一の親ID
			$pPageArray = $pageTb->selectParentID($parentID);
			//全ページ数回繰り返す	
			foreach ($pPageArray as $page) {
				$wkPri = $page->getPriority();
				//優先順位が大きい場合
				if ( $wkPri > $priority ) {
					//優先順位を変更して、ページの更新
					$page->setPriority($wkPri - 1);
					$page->update($page->getID());
				}
			}

			//ログを削除
			$logTb = new log_tb();
			$logTb->deleteByPageID($id);

			//スキーマから指定ページを削除
			$pageSchema = new schema_tb();
			//スキーマを検索
			$schemaArray = $pageSchema->selectTemplatePageID($tmpID);
			//スキーマが存在した場合
			if ( $schemaArray != null ) {
				$pageAttr = new page_attribute_tb();
				//ページ属性を取得
				$pageAttrArray = $pageAttr->selectPageID($tmpID,$id);
				//属性が存在する場合
				if ( $pageAttrArray != null ) {
					//スキーマ数回繰り返す
					foreach ( $schemaArray as $schema ) {
						//スキーマが画像だった場合
						$typeValue = $schema->getVariableType();
						if ( $typeValue == 4 ) {
							$vari = $schema->getVariable();
							//ページ画像を削除
							image_tb::deleteAttributeImageFile($id,$vari);
						}
					}
					//削除を行う
					$pageAttr->delete($tmpID,$id);
				}
			}

			//画像ファイルの削除を行う
			image_tb::deletePageImageFile($id,1);
			image_tb::deletePageImageFile($id,2);
			image_tb::deletePageImageFile($id,3);
			image_tb::deletePageImageFile($id,4);
			image_tb::deletePageImageFile($id,5);

			//ページを削除
			$pageData->delete($id);
			//メッセージを設定しました。
			$msg = "ページ削除を行いました。";
		}

	} else {
		$msg = "ルートのページ削除は行えません。";
	}
	//テンプレートデータを設定
	$smarty->assign('msg',$msg);
	//ページ基本テンプレートを設定
	$page_template = "page/page_delete.tpl";
	//ページを移動する
	$smarty->display($page_template);

} else {

	//IDを取得
	$wkid = $_GET['id'];
	//親に設定	
	$parent_id = $wkid;

	$tempSite = "";
	$tempPage = "";
	
	
	//上部のページを検索
	$pageTb = new page_tb();
	$pageArray = $pageTb->selectByID($parent_id);
	//検索でみつかった場合
	if ( $pageArray != null && count($pageArray) != 0 ) {
		$tempPageID = $pageArray[0]->getTemplate_Page_ID();
		//ページテンプレートを取得
		$tempPageTb = new template_page_tb();
		//ページテンプレートを取得
		$pageTempArray = $tempPageTb->selectByID($tempPageID);
		//テンプレートが存在した場合
		if ( $pageTempArray != null && count($pageTempArray) != 0 ) {
			//テンプレートを取得
			$tempTb = $pageTempArray[0];
			//指定してあるIDで設定する
			$tempSite = $tempTb->getChildrenTemplateSiteID();
			$tempPage = $tempTb->getChildrenTemplatePageID();
		}
	}

	//サイトのセレクションボックスを取得
	$selection_site   = template_site_tb::getSelection($tempSite);
	//ページのセレクションボックスを取得
	$selection_page   = template_page_tb::getSelection($tempPage);
	
	//ページ基本テンプレートを設定
	$page_template = "page/page_editing.tpl";
	
	//テンプレートデータを設定
	$smarty->assign('id',$id);
	$smarty->assign('parent_id',$parent_id);
	$smarty->assign('name',$name);
	$smarty->assign('detail',$detail);
	$smarty->assign('alias',$alias);
	$smarty->assign('selection_site',$selection_site);
	$smarty->assign('selection_page',$selection_page);
	$smarty->assign('createdate',$createdate);
	$smarty->assign('editdate',$editdate);

	//表示テンプレート
	$smarty->display($page_template);
}
//********************************************************
?>